#
# UPDATE WARNING: xtables-addons 2.0 support only kernels 3.7+
#                 xtables-addons 3.0 (XTADDONS_3 branch) support only kernels 4.15+ in kernel modules part
#
# Conditional build:
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace tools
%bcond_with	verbose		# verbose build (V=1)

# The goal here is to have main, userspace, package built once with
# simple release number, and only rebuild kernel packages with kernel
# version as part of release number, without the need to bump release
# with every kernel change.
%if 0%{?_pld_builder:1} && %{with kernel} && %{with userspace}
%{error:kernel and userspace cannot be built at the same time on PLD builders}
exit 1
%endif

%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		rel	6
%define		pname	xtables-addons
Summary:	Additional extensions for xtables packet filtering system
Summary(pl.UTF-8):	Dodatkowe rozszerzenia do systemu filtrowania pakietów xtables
Name:		%{pname}-2%{?_pld_builder:%{?with_kernel:-kernel}}%{_alt_kernel}
Version:	2.14
Release:	%{rel}%{?_pld_builder:%{?with_kernel:@%{_kernel_ver_str}}}
License:	GPL v2
Group:		Networking/Admin
Source0:	http://downloads.sourceforge.net/xtables-addons/%{pname}-%{version}.tar.xz
# Source0-md5:	ebb073119a5f250dbfe6b855fcad56fd
Patch0:		kernel-4.15.patch
Patch1:		kernel-4.9.256.patch
URL:		http://xtables-addons.sourceforge.net/
BuildRequires:	autoconf >= 2.65
BuildRequires:	automake >= 1:1.11
BuildRequires:	iptables-devel >= 1.4.5
%{?with_kernel:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:3.7.0}}
BuildRequires:	libtool
BuildRequires:	pkgconfig >= 0.9.0
BuildRequires:	rpmbuild(macros) >= 1.678
BuildRequires:	tar >= 1.22
BuildRequires:	xz
Requires:	iptables >= 1.4.5
Obsoletes:	iptables-ipp2p
BuildRoot:	%{tmpdir}/%{pname}-%{version}-root-%(id -u -n)

%define		_duplicate_files_terminate_build	0

%description
xtables-addons is the proclaimed successor to patch-o-matic(-ng). It
contains extensions that were not accepted in the main
xtables/iptables package.

For the tools to work, you should install kernel modules, which could
be found in kernel*-net-xtables-addons.

%description -l pl.UTF-8
xtables-addons to następca patch-o-matic(-ng). Zawiera rozszerzenia,
które nie zostały zaakceptowane do głównego pakietu xtables/iptables.

Aby narzędzia działały należy zainstalować moduły jądra, które można
znaleźć w pakiecie kernel*-net-xtables-addons.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-net-xtables-addons\
Summary:	Kernel modules for xtables addons\
Summary(pl.UTF-8):	Moudły jądra dla rozszerzeń z pakietu xtables-addons\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
# VERSION only dependency is intentional, for allowing multiple kernel pkgs and\
# single userspace package installs.\
Requires:	%{pname}-2 >= %{version}\
Suggests:	xtables-geoip\
Conflicts:	xtables-geoip < 20090901-2\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-net-xtables-addons\
Kernel modules for xtables addons.\
\
%description -n kernel%{_alt_kernel}-net-xtables-addons -l pl.UTF-8\
Moduły jądra dla rozszerzeń z pakietu xtables-addons.\
\
%files -n kernel%{_alt_kernel}-net-xtables-addons\
%defattr(644,root,root,755)\
# restricted permissions - may contain password\
%attr(600,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/xt_sysrq.conf\
/lib/modules/%{_kernel_ver}/kernel/net/netfilter/compat_xtables.ko*\
/lib/modules/%{_kernel_ver}/kernel/net/netfilter/xt_*.ko*\
\
%post -n kernel%{_alt_kernel}-net-xtables-addons\
%depmod %{_kernel_ver}\
\
%postun -n kernel%{_alt_kernel}-net-xtables-addons\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
srcdir=${PWD:-$(pwd)}\
%build_kernel_modules XA_ABSTOPSRCDIR=$srcdir -C extensions -m compat_xtables\
for drv in extensions/compat_xtables.ko extensions/{ACCOUNT/,pknock/,}xt_*.ko ; do\
%install_kernel_modules -D installed -m ${drv%.ko} -d kernel/net/netfilter\
done\
%{nil}

%{?with_kernel:%{expand:%create_kernel_packages}}

%prep
%setup -q -n %{pname}-%{version}
%patch0 -p1
%patch1 -p1

%build
%configure \
	--without-kbuild

%{?with_kernel:%{expand:%build_kernel_packages}}

%if %{with userspace}
%{__make} \
	V=1
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with kernel}
install -d $RPM_BUILD_ROOT/etc/modprobe.d

cp -a installed/* $RPM_BUILD_ROOT

cat <<'EOF' > $RPM_BUILD_ROOT/etc/modprobe.d/xt_sysrq.conf
# Set password at modprobe time. This file is secure if properly guarded,
# i.e only readable by root.
#options xt_SYSRQ password=cookies

# The hash algorithm can also be specified as a module option, for example,
# to use SHA-256 instead of the default SHA-1:
#options xt_SYSRQ hash=sha256
EOF
%endif

%if %{with userspace}
%{__make} -C extensions install \
	DESTDIR=$RPM_BUILD_ROOT
%{__make} install-man \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} $RPM_BUILD_ROOT%{_libdir}/libxt_ACCOUNT_cl.{la,so}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc README doc/{README.psd,changelog.txt}
%attr(755,root,root) %{_sbindir}/iptaccount
%attr(755,root,root) %{_libdir}/libxt_ACCOUNT_cl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libxt_ACCOUNT_cl.so.0
%attr(755,root,root) %{_libdir}/xtables/libxt_*.so
%{_mandir}/man8/iptaccount.8*
%{_mandir}/man8/xtables-addons.8*
%endif
%changelog
* Fri Dec 31 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xtables-addons.git;a=log;h=auto/th/xtables-addons-2-2.14-6

* Sat Feb 06 2021 Jan Rękorajski <baggins@pld-linux.org> ffb7c91
- fix building with kernel 4.9.256
- rel 6

* Wed Oct 31 2018 Jan Rękorajski <baggins@pld-linux.org> 62a8aaf
- fix internal deps
- rel 5

* Sat Aug 18 2018 Jan Rękorajski <baggins@pld-linux.org> 1f2e55f
- rename main/src package to xtables-addons-2 to avoid ftp automation conflicts

* Sat Aug 18 2018 Jan Rękorajski <baggins@pld-linux.org> 44a5d73
- relax kernel package deps since xtaddons 3.x userland supports old kernels
- rel 3

* Fri Aug 17 2018 Jan Rękorajski <baggins@pld-linux.org> fb7f958
- rel 2

* Thu Jul 12 2018 Jakub Bogusz <qboosh@pld-linux.org> d8e895a
- more precise information (3.0 userspace part didn't introduce incompatibilities with Linux 3.7 .. 4.14)

* Thu Jul 12 2018 Jakub Bogusz <qboosh@pld-linux.org> bf80647
- xtables-addons 3.0 note

* Tue Jan 30 2018 Jan Rękorajski <baggins@pld-linux.org> c0b838d
- up to 2.14
- upstream fix for kernel 4.15

* Thu Nov 16 2017 Jan Rękorajski <baggins@pld-linux.org> 3bff943
- fix building with kernel 4.14
- rel 2

* Tue Aug 01 2017 Jan Rękorajski <baggins@pld-linux.org> 8415008
- up to 2.13

* Sun Mar 26 2017 Jakub Bogusz <qboosh@pld-linux.org> 4f3fc9f
- release 2 (rebuild userspace with iptables 1.6.1)

* Sat Jan 21 2017 Jan Rękorajski <baggins@pld-linux.org> b351b59
- up to 2.12

* Mon Jun 06 2016 Jan Rękorajski <baggins@pld-linux.org> 7529846
- up to 2.11

* Sat Apr 16 2016 Jan Rękorajski <baggins@pld-linux.org> 07ae6fd
- rel 2

* Thu Dec 03 2015 Jan Rękorajski <baggins@pld-linux.org> b8a11eb
- up to 2.10

* Sun Sep 27 2015 Jan Rękorajski <baggins@pld-linux.org> 4a6f4b9
- up to 2.8

* Sat Jul 04 2015 Jan Rękorajski <baggins@pld-linux.org> 586530d
- uopdated to 2.6
- fixed building with linux 4.1

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 3eae76a
- x32 rebuild
- release 3 (by relup.sh)

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> 2199654
- rel 2

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> fbbd40f
- updated kernel modules build system

